{$F+}
{ Kvashnin S.E.}
Unit BisecU;
                       interface
Uses Kernel;
type
   TypeFun = function(x: RealType) : RealType;
   Function bisec(FexZ: TypeFun; a,b: RealType; epsx : RealType;
                         var signal : boolean) : RealType;

   implementation

   Function bisec(FexZ: TypeFun; a,b: RealType; epsx : RealType;
                         var signal : boolean) : RealType;
      Label 1,2,cont;
      var c, ya,yb,yc,st : RealType;
   begin
      signal:=true;
      st:=b-a;
      ya:=FexZ(a);
cont: yb:=FexZ(b);
      if ya*yb > 0 then
         begin
           ya:=yb;
           a:=b;
           b:=b+st;
           goto cont;
         end;
   1:   c:=(a+b)/2.0;
        yc:=FexZ(c);
        if (abs(a-b)< epsx) then goto 2;
        if (yc*ya > 0) then
             begin a:=c; ya:=yc; goto 1 end
                 else begin b:=c; yb:=yc; goto 1 end;
  2:    if (yc*ya > 0) then
             begin a:=c; ya:=yc end
                 else begin b:=c; yb:=yc end;
        bisec:=a+(a-b)*ya/(yb-ya);
      end;
end.