{$F+}
                    { 28.07.93 }
  UNIT ZeroinU;
                          INTERFACE
  USES Kernel;

  type
     ProcTypeZer = Function ( T : RealType): RealType;

  function Zeroin (Fex: ProcTypeZer; ax,bx,tol: RealType;
                   var signal : boolean; var iter : integer): RealType; far;

                         Implementation

{ Kvashnin S.E. -  correction 29.09.91 }
  function Zeroin (Fex: ProcTypeZer; ax,bx,tol: RealType;
                   var signal : boolean; var iter : integer): RealType;
{  室  楤 iter  ࠢ ᨬ쭮 ⨬ 
  権,  室 iter - ᫮ 権
  signal=true - ᫨ ७ ,  - false }

  label 10, 20,30,40,70,80,90,cont;
    var
      a,b,c,d,e,eps,fa,fb,fc,tol1,xm,p,q,r,s      : RealType;
      st,itmax                                    : RealType;

    function sign(x,y : real): integer;
      var  a : RealType;
      begin
        sign:=round(y/abs(y)*abs(x));
      end;

    begin
      zeroin:=0;
      itmax:=iter;
      iter:=0;
      signal:=false;
      eps:=1.0;
10:   eps:=eps/2.0;
      tol1:=1.0+eps;
      if tol1 > 1.0 then goto 10;
   {-------------my----------------------}
      a:=ax; b:=bx;
      st:=b-a;
      fa:=Fex(a);
      inc(iter);
cont: fb:=Fex(b);
      inc(iter); if iter > itMax then exit;
      if fa/abs(fa)*fb > 0 then
         begin
           fa:=fb;
           a:=b;
           b:=b+st;
           goto cont;
         end;

20:   c:=a;
      fc:=fa;
      d:=b-a;
      e:=d;
30:   if abs(fc) >= abs(fb) then goto 40;
      a:=b; b:=c; c:=a; fa:=fb; fb:=fc;fc:=fa;
40:   tol1:=2.0*eps*abs(b)+0.5*tol;
      xm:=0.5*(c-b);
      if abs(xm) <= tol1 then goto 90;
      if fb =0.0 then goto 90;
      if abs(e) < tol1 then goto 70;
      if abs(fa) <= abs(fb) then goto 70;
      if a = c then
        begin
          s:=fb/fa;
          p:=2.0*xm*s;
          q:=1.0-s;
        end
      else
        begin
          q:=fa/fc; r:=fb/fc; s:=fb/fa;
          p:=s*(2.0*xm*q*(q-r)-(b-a)*(r-1.0));
          q:=(q-1.0)*(r-1.0)*(s-1.0);
        end;
      if p > 0.0 then q:=-q;
      p:=abs(p);
      if((2.0*p) >= (3.0*xm*q-abs(tol1*q)))or (p >= abs(0.5*e*q)) then goto 70;
      e:=d; d:=p/q;
      goto 80;
70:   d:=xm; e:=d;
80:   a:=b; fa:=fb;
      if abs(d) > tol1 then b:=b+d;
      if abs(d) <= tol1 then b:=b+sign(tol1,xm);
      fb:=Fex(b);
      inc(iter); if iter > itMax then exit;
      if fb*(fc/abs(fc)) > 0.0 then goto 20 else goto 30;
90:   Zeroin:=b;
      signal:=true;
  end;

{****************************************************************************}
end.